#include <sourcemod>
#include <csgo_colors>
#include <shop>

public Plugin myinfo = 
{
	name = "[SHOP] MAPKILLS BONUS",
	author = "Drimer",
	description = "",
	version = "1.4",
	url = "http://spartdrim.ru"
};

Handle g_hKV;
int g_iKills[MAXPLAYERS+1];
int g_iMKB;
StringMap g_hMKBInfo;

int minplayers;

int g_iProcent;

char g_sCommandName[64];

char g_sPrefix[64];


public void OnPluginStart()
{
	//RegConsoleCmd("sm_kb", kb);
	RegAdminCmd("sm_bonus_reload", reload, ADMFLAG_ROOT, "sm_bonus_reload <#userid|name>");
	HookEvent("player_death", Event_PlayerDeath);
	if (Shop_IsStarted()) Shop_Started();
	
	
	g_hMKBInfo = new StringMap();
}

public OnClientDisconnect(int iClient)
{
	g_iKills[iClient] = 0;
}

public Shop_Started()
{
	Shop_AddToFunctionsMenu(FunctionDisplay, FunctionSelect);
}

public FunctionDisplay(iClient, String:buffer[], maxlength)
{
	strcopy(buffer, maxlength, "Бонусы за киллы");
}

public bool FunctionSelect(iClient)
{
	BonusMenu_Main(iClient);

	return true;
}

public void OnPluginEnd()
{
	Shop_UnregisterMe();
}

GetCount()
{
	int j;
	for (int i = 1; i <= MaxClients; i++)
	{
		if(IsClientInGame(i) && GetClientTeam(i) > 1) j++;
	}
	return j;
}

public Action reload(int iClient, int args)
{
	if(args == 1)
	{
		decl String:arg[65];
		GetCmdArg(1, arg, sizeof(arg));

		decl String:target_name[MAX_TARGET_LENGTH];
		decl target_list[MAXPLAYERS], target_count, bool:tn_is_ml;

		if ((target_count = ProcessTargetString(
						arg,
						iClient,
						target_list,
						MAXPLAYERS,
						COMMAND_FILTER_CONNECTED|COMMAND_FILTER_NO_BOTS,
						target_name,
						sizeof(target_name),
						tn_is_ml)) <= 0)
		{
			ReplyToCommand(iClient, "[SM] No matching client");
			return Plugin_Handled;
		}


		for (new i = 0; i < target_count; i++)
		{
			g_iKills[target_list[i]] = 0;
		}
	}
	
	return Plugin_Handled;
}

public void OnMapStart()
{
	g_hMKBInfo.Clear();

	KFG_Load();
	for (int i = 0; i < MaxClients; ++i)    
	{
		g_iKills[i] = 0;
	}
}


void BonusMenu_Main(int iClient)
{
	if(GetCount()>= minplayers)
		{
			Menu hMenu = new Menu(Menu_MainMenu);
			hMenu.SetTitle("Твои киллы: %i", g_iKills[iClient]);
			char szBuffer[128], STIGroups[16], sBuffer[128], sBufs[3][64], sName[64];
			for(int i = 0, iKills; i <= g_iMKB; ++i)
			{
				IntToString(i, STIGroups, 16);
				g_hMKBInfo.GetString(STIGroups, sBuffer, 128);
				ExplodeString(sBuffer, ";", sBufs, 3, 64);
				strcopy(sName, 64, sBufs[0]);
				iKills = StringToInt(sBufs[2]);
				if(g_iKills[iClient] >= iKills) hMenu.AddItem(sBuffer, sName);
				else
				{
					
					FormatEx(szBuffer, 128, "%s [%i киллов]", sName, iKills);
					hMenu.AddItem(sBuffer, szBuffer, ITEMDRAW_DISABLED);
				}
			}
			hMenu.AddItem("", "Описание");
			hMenu.Display(iClient, MENU_TIME_FOREVER);
		}
		else CGOPrintToChat(iClient," {LIGHTGREEN}[{LIGHTRED}%s{LIGHTGREEN}] {DEFAULT}На сервере слишком мало игроков {LIGHTGREEN}%i{DEFAULT}/{LIGHTGREEN}%i",g_sPrefix,GetCount(),minplayers)
}

public Action sm_kb(int iClient, int args)
{
	if(GetCount()>= minplayers)
	{
		Menu hMenu = new Menu(Menu_MainMenu);
		hMenu.SetTitle("Твои киллы: %i", g_iKills[iClient]);
		char szBuffer[128], STIGroups[16], sBuffer[128], sBufs[3][64], sName[64];
		for(int i = 0, iKills; i <= g_iMKB; ++i)
		{
			IntToString(i, STIGroups, 16);
			g_hMKBInfo.GetString(STIGroups, sBuffer, 128);
			ExplodeString(sBuffer, ";", sBufs, 3, 64);
			strcopy(sName, 64, sBufs[0]);
			iKills = StringToInt(sBufs[2]);
			if(g_iKills[iClient] >= iKills) hMenu.AddItem(sBuffer, sName);
			else
			{
				
				FormatEx(szBuffer, 128, "%s [%i киллов]", sName, iKills);
				hMenu.AddItem(sBuffer, szBuffer, ITEMDRAW_DISABLED);
			}
		}
		hMenu.AddItem("", "Описание");
		hMenu.Display(iClient, MENU_TIME_FOREVER);
	}
	else CGOPrintToChat(iClient," {LIGHTGREEN}[{LIGHTRED}%s{LIGHTGREEN}] {DEFAULT}На сервере слишком мало игроков {LIGHTGREEN}%i{DEFAULT}/{LIGHTGREEN}%i",g_sPrefix,GetCount(),minplayers)
}

public Event_PlayerDeath(Event event, const char[] name, bool dontBroadcast)
{	
	if(GetCount()>= minplayers)
	{
		int iClient = GetClientOfUserId(event.GetInt("attacker"));
		if(iClient > 0)
		{
			++g_iKills[iClient];
			if(!(g_iKills[iClient] % g_iProcent))
			{
				CGOPrintToChat(iClient," {LIGHTGREEN}[{RED}%s{LIGHTGREEN}] {DEFAULT}Вы набрали {LIGHTGREEN}%i {DEFAULT}киллов,вы можете получить бонус написав {LIGHTGREEN}%s ",g_sPrefix,g_iKills[iClient],g_sCommandName)
			}
		}
	}
}

public Menu_MainMenu(Menu hMenu, MenuAction action, int iClient, int iItem)
{
	switch(action)
	{
		case MenuAction_Select:
		{
			char sInfo[128];
			hMenu.GetItem(iItem, sInfo, 128);
			if(sInfo[0])
			{
				char sBufs[3][64], sName[64];
				int iCredits, iKills;
				ExplodeString(sInfo, ";", sBufs, 3, 64);
				strcopy(sName, 64, sBufs[0]);
				iCredits = StringToInt(sBufs[1]);
				iKills = StringToInt(sBufs[2]);
				CGOPrintToChat(iClient, "{LIGHTGREEN}[{RED}%s{LIGHTGREEN}] Вы набили {LIGHTGREEN}%i киллов {DEFAULT}и получаете {LIGHTGREEN}%i кредитов",g_sPrefix, iKills, iCredits);
				g_iKills[iClient] = g_iKills[iClient] - iKills;
				Shop_GiveClientCredits(iClient, iCredits, IGNORE_FORWARD_HOOK);
			}
			else
			{
				CGOPrintToChat(iClient,"----------------{LIGHTBLUE}ОПИСАНИЕ{DEFAULT}----------------");
				CGOPrintToChat(iClient,"{RED}1. {LIGHTGREEN}За 1 карту вы должны набрать нужное кол-во убийств что бы получить бонусы.");
				CGOPrintToChat(iClient,"{RED}2. {LIGHTGREEN}При получении бонусов снимается столько киллов сколько требуется для бонуса.");
				CGOPrintToChat(iClient,"{RED}3. {LIGHTGREEN}После перезахода на сервер киллы остаются(на время карты).");
				CGOPrintToChat(iClient,"----------------{LIGHTBLUE}ОПИСАНИЕ{DEFAULT}----------------");
			}
		}
		case MenuAction_End: delete hMenu;
	}
}

void KFG_Load()
{
	if(g_hKV) delete g_hKV;
	char buffer[PLATFORM_MAX_PATH], g[64], STIGroups[16], sBuffer[128], sName[64];
	int iCredits, iKills;
	g_hKV = CreateKeyValues("mapbonus");
	BuildPath(Path_SM, buffer, sizeof buffer, "configs/mapkillbonus.ini");
	FileToKeyValues(g_hKV, buffer);
	decl String:ui[32][32], String:uo[512];
	KvGetString(g_hKV, "command", uo, 512, "sm_kb");
	new jl = ExplodeString(uo, ";", ui, 32, 32);
	for (new i = 0; i < jl; i++) RegConsoleCmd(ui[i], sm_kb);
	minplayers = KvGetNum(g_hKV, "min_players");
	g_iProcent = KvGetNum(g_hKV, "killstime");
	KvGetString(g_hKV,"commandname",g_sCommandName, 64);
	KvGetString(g_hKV,"prefix",g_sPrefix, 64);
	KvRewind(g_hKV);
	KvJumpToKey(g_hKV,"bonus", false);
	KvGotoFirstSubKey(g_hKV, true);
	g_iMKB = -1;
	do 
	{
		if (KvGetSectionName(g_hKV, g, 64))
		{
			
			++g_iMKB;
			IntToString(g_iMKB, STIGroups, 16);
			KvGetString(g_hKV, "name", sName, 64);
			iCredits = KvGetNum(g_hKV, "credits");
			iKills = KvGetNum(g_hKV, "kills");
			FormatEx(sBuffer, 128, "%s;%i;%i", sName, iCredits, iKills);
			g_hMKBInfo.SetString(STIGroups, sBuffer);
		}
	} while (KvGotoNextKey(g_hKV, true));
}